@echo off
REM ------------------------------------------------------------
REM Bazaar Visual Studio Integration v0.1 by Fabian Schlieper (http://fabi.me/)
REM ------------------------------------------------------------

if not "%1"=="commit" if "%4"=="" set /p sPassword=Enter password:

goto %1

:commit
set /p sDesc=Description of the new revision:
bzr.exe commit -m "%sDesc%"
goto finished
:end

:merge
for /F "delims=. tokens=1" %%i in ("%3") do set sBranch=%%i
echo Updating/Merging branch %sBranch:~1% from %2
for /F "delims=@ tokens=1" %%i in ("%2") do set sPart1=%%i
for /F "delims=@ tokens=2" %%i in ("%2") do set sPart2=%%i
bzr.exe merge "%sPart1%:%sPassword%@%sPart2%%sBranch:~1%"

for /f %%l in ('bzr.exe diff') do set diff=%%l
if "%diff%"=="" goto finished
echo Modified files:
bzr.exe diff
echo ========================================
echo Changes have to be commited to local branch.
call bzr_vstools.bat commit
:finalpush
goto finished
:end

:update
for /F "delims=. tokens=1" %%i in ("%3") do set sBranch=%%i
echo Updating branch %sBranch:~1% from %2
for /F "delims=@ tokens=1" %%i in ("%2") do set sPart1=%%i
for /F "delims=@ tokens=2" %%i in ("%2") do set sPart2=%%i
bzr.exe update "%sPart1%:%sPassword%@%sPart2%%sBranch:~1%"
goto finished
:end

:push
for /F "delims=. tokens=1" %%i in ("%3") do set sBranch=%%i
echo Publishing branch %sBranch:~1% to %2
for /F "delims=@ tokens=1" %%i in ("%2") do set sPart1=%%i
for /F "delims=@ tokens=2" %%i in ("%2") do set sPart2=%%i
bzr.exe push --create-prefix "%sPart1%:%sPassword%@%sPart2%%sBranch:~1%"
goto finished
:end

:cmp
call bzr_vstools.bat commit
call bzr_vstools.bat merge %2 %3 %sPassword%
call bzr_vstools.bat push %2 %3 %sPassword%
goto finished
:end

:log

goto finished
:end

:finished

:end